> For the complete documentation index, see [llms.txt](https://docs.sonarsource.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.sonarsource.com/sonarqube-server/9.9/analyzing-source-code/importing-external-issues/generic-issue-import-format.md).

# Generic issue import format

SonarQube Server 9.9 supports a generic import format for raising external issues in code.

{% hint style="info" %}
**For AI agents:** You're in the SonarQube Server 9.9 documentation. For a list of all 9.9 pages, see the [SonarQube Server 9.9 page index](https://152261287-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FBmptmznn7RpPe5u7vdup%2Fuploads%2F7O6jgZAiehDGe0FMXDaC%2Fsonarqube-server-9.9-llms.txt?alt=media). For the whole site, see the [page index](https://docs.sonarsource.com/llms.txt) or the [full text](https://docs.sonarsource.com/llms-full.txt). For another version, replace 9.9 in the URL with that version. The [latest version](https://docs.sonarsource.com/sonarqube-server/) has no version number in its URL.
{% endhint %}

SonarQube Server supports a generic import format for raising external issues in code. You can use this format to import issues from your favorite linter even if there’s no plugin for it. SonarQube Server also supports [Importing third-party issues](/sonarqube-server/9.9/analyzing-source-code/importing-external-issues/importing-third-party-issues.md), and [Importing issues from SARIF reports](/sonarqube-server/9.9/analyzing-source-code/importing-external-issues/importing-issues-from-sarif-reports.md).

External issues and the rules that raise them must be managed in the configuration of your linter.

## Import <a href="#import" id="import"></a>

The analysis parameter `sonar.externalIssuesReportPaths` accepts a comma-delimited list of paths to reports.

Each report must contain, at the top level, an array of `Issue` objects named `issues`.

**Issue fields:**

* `engineId` - String
* `ruleId` - String
* `primaryLocation` - Location object
* `type` - String. One of BUG, VULNERABILITY, CODE\_SMELL
* `severity` - String. One of BLOCKER, CRITICAL, MAJOR, MINOR, INFO
* `effortMinutes` - Integer, optional. Defaults to 0
* `secondaryLocations` - Array of Location objects, optional

**Location fields:**

* `message` - String
* `filePath` - String
* `textRange` - TextRange object, optional for secondary locations only

**TextRange fields:**

* `startLine` - Integer. 1-indexed
* `endLine` - Integer, optional. 1-indexed
* `startColumn` - Integer, optional. 0-indexed
* `endColumn` - Integer, optional. 0-indexed

## Example <a href="#example" id="example"></a>

Here is an example of the expected format:

```css-79elbk
{ "issues": [
    {
      "engineId": "test",
      "ruleId": "rule1",
      "severity":"BLOCKER",
      "type":"CODE_SMELL",
      "primaryLocation": {
        "message": "fully-fleshed issue",
        "filePath": "sources/A.java",
        "textRange": {
          "startLine": 30,
          "endLine": 30,
          "startColumn": 9,
          "endColumn": 14
        }
      },
      "effortMinutes": 90,
      "secondaryLocations": [
        {
          "message": "cross-file 2ndary location",
          "filePath": "sources/B.java",
          "textRange": {
            "startLine": 10,
            "endLine": 10,
            "startColumn": 6,
            "endColumn": 38
          }
        }
      ]
    },
    {
      "engineId": "test",
      "ruleId": "rule2",
      "severity": "INFO",
      "type": "BUG",
      "primaryLocation": {
        "message": "minimal issue raised at file level",
        "filePath": "sources/Measure.java"
      }
    }
]}
```

## Limitations <a href="#limitations" id="limitations"></a>

There are a couple of limitations with importing external issues:

* You can’t manage them within SonarQube Server. For example, you can’t mark them as false positives.
* You can’t manage the activation of the rules that raise these issues within SonarQube Server. External rules aren’t visible on the Rules page or reflected in quality profiles.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.sonarsource.com/sonarqube-server/9.9/analyzing-source-code/importing-external-issues/generic-issue-import-format.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
